unit Registraunit;

interface

uses ActiveX;
const
  E_FAIL = $80004005;
  S_FALSE = $00000001;
  S_OK    = $00000000;

type
 HINST = Integer;
 DWORD = Integer;
 THandle = Integer;
 HMODULE = HINST;
 LPCSTR = PAnsiChar;
 FARPROC = Pointer;

  function UpdateRegistryLib(Register: Boolean; TypelibName : string): HResult;
  function ModuleFileName: string;



///These functions need to be here because of a bug in the D3 compiler/fixed in D4
function GetModuleFileName(hModule: HINST; lpFilename: PChar; nSize: DWORD): DWORD; stdcall;
function GetModuleHandle(lpModuleName: PChar): HMODULE; stdcall;
function GetProcAddress(hModule: HMODULE; lpProcName: LPCSTR): FARPROC; stdcall;

implementation
const
  kernel32  = 'kernel32.dll';
function GetModuleFileName; external kernel32 name 'GetModuleFileNameA';
function GetModuleHandle; external kernel32 name 'GetModuleHandleA';
function GetProcAddress; external kernel32 name 'GetProcAddress';


function ModuleFileName: string;
var
  Buffer: array[0..261] of Char;
begin
  SetString(Result, Buffer, GetModuleFileName(HInstance,
    Buffer, SizeOf(Buffer)));
end;

function UnregisterTypeLibrary(TypeLib: ITypeLib):HRESULT;
type
  TUnregisterProc = function(const GUID: TGUID; VerMajor, VerMinor: Word;
    LCID: TLCID; SysKind: TSysKind): HResult stdcall;
var
  Handle         : Integer;
  UnregisterProc : TUnregisterProc;
  LibAttr        : PTLibAttr;
begin
  Handle := GetModuleHandle('OLEAUT32.DLL');
  Result := E_FAIL;
  if (Handle <> 0) and (Handle > 32) then
  begin
    @UnregisterProc := GetProcAddress(Handle, 'UnRegisterTypeLib');
    if @UnregisterProc <> nil then
    begin
      Result := TypeLib.GetLibAttr(LibAttr);
      if Result = S_OK then
      begin
       with LibAttr^ do
         Result := UnregisterProc(guid, wMajorVerNum, wMinorVerNum, lcid, syskind);
       TypeLib.ReleaseTLibAttr(LibAttr);
      end;
    end;
  end;
end;

function UpdateRegistryLib(Register: Boolean; TypelibName : string): HResult;
var
  TypeLib: ITypeLib;
begin
  Result  := LoadTypeLib(StringToOLEStr(TypelibName), Typelib);
  if (TypeLib <> nil) and (Result = S_OK) then
    if Register then
      Result := RegisterTypeLib(TypeLib, StringToOLEStr(TypelibName), StringToOLEStr(TypelibName))
    else
      Result := UnregisterTypeLibrary(TypeLib);
end;

end.
